<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar de Perfil Usuario</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear un para un Usuario?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col :sm="12" :md="6" :lg="6">
            <v-list>
              <v-subheader>Perfiles Fijos</v-subheader>
              <draggable
                v-model="perfilesUsuarioFijos"
                v-bind="{
                  draggable: '.item',
                  ghostClass: 'ghost',
                  animation: 200,
                  disabled: true
                }"
                handle=".drag"
                @change="onDragDrop"
                style="max-height: 200px; min-height: 200px; overflow: auto; border: solid 2px grey;"
              >
                <v-list-item
                  v-for="(perfilUsuario, indexPerfil) in perfilesUsuarioFijos"
                  :key="indexPerfil + 1"
                  class="item"
                >
                  <v-list-item-content>
                    <v-list-item-title>{{
                      perfilUsuario.perfil.descripcion
                    }}</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </draggable>
              <draggable
                v-model="perfilesUsuarioAsociados"
                v-bind="{
                  group: 'perfiles',
                  draggable: '.item',
                  ghostClass: 'ghost',
                  animation: 200
                }"
                handle=".drag"
                @change="onDragDrop"
                style="min-height: 200px;border: 2px dashed grey;border-top: none;"
              >
                <v-list-item
                  v-for="(perfilUsuario,
                  indexPerfilUsuario) in perfilesUsuarioAsociados"
                  :key="indexPerfilUsuario + 1"
                  class="item"
                >
                  <v-list-item-icon>
                    <v-icon @click="deleteAssociatePerfilUsuario(perfilUsuario)"
                      >mdi-trash-can</v-icon
                    >
                  </v-list-item-icon>
                  <v-list-item-content>
                    <v-list-item-title
                      v-text="
                        serviceCommons.titleCase(
                          perfilUsuario.perfil.descripcion
                        )
                      "
                    />
                  </v-list-item-content>
                </v-list-item>
              </draggable>
            </v-list>
          </v-col>
          <v-col :sm="12" :md="6" :lg="6">
            <v-list subheader>
              <v-subheader>Perfiles disponibles</v-subheader>
              <draggable
                v-model="perfilesUsuarioDisponibles"
                v-bind="{
                  group: 'perfiles',
                  draggable: '.item',
                  ghostClass: 'ghost',
                  animation: 200
                }"
                @change="onDragDrop"
                style="max-height: 400px; min-height: 400px; overflow: auto; border: solid 2px grey;"
                handle=".drag"
                @start="drag = true"
                @end="drag = false"
              >
                <transition-group
                  type="transition"
                  :name="!drag ? 'flip-list' : null"
                >
                  <v-list-item
                    class="item"
                    v-for="(perfilUsuario,
                    indexPerfil) in perfilesUsuarioDisponibles"
                    :key="indexPerfil + 'index'"
                    no-action
                  >
                    <v-list-item-icon>
                      <v-icon class="drag">mdi-cursor-move</v-icon>
                    </v-list-item-icon>
                    <v-list-item-content>
                      <v-list-item-title
                        v-text="
                          serviceCommons.titleCase(
                            perfilUsuario.perfil.descripcion
                          )
                        "
                      />
                    </v-list-item-content>
                  </v-list-item>
                </transition-group>
              </draggable>
            </v-list>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
    </div>
  </div>
</template>
<style scoped>
.button {
  margin-top: 35px;
}
.flip-list-move {
  transition: transform 0.5s;
}
.no-move {
  transition: transform 0s;
}
.ghost {
  opacity: 0.5;
  background: #c8ebfb;
}
.list-group {
  min-height: 20px;
}
.list-group-item {
  cursor: move;
}
.list-group-item i {
  cursor: pointer;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import draggable from "vuedraggable";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "PerfilUsuarioPersonalizado",
  components: {
    draggable
  },
  data() {
    return {
      moment: moment,
      drag: null,
      usuario: null,
      open: [],
      active: [],
      removed: null,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios"
          }
        },
        {
          text: "Usuarios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_usuario"
          }
        }
      ],
      perfilesUsuarioDisponibles: [],
      perfilesUsuarioFijos: [],
      perfilesUsuarioAsociados: []
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    initValues() {
      this.breadcrumbs.push({
        text: this.serviceCommons.titleCase(this.usuario.nombre_usuario),
        disabled: false,
        exact: true,
        to: {
          name: "privilegios_usuario",
          params: {
            usuario: this.serviceCommons.objectToBase64(this.usuario)
          }
        }
      });
      this.breadcrumbs.push({
        text: "Perfiles",
        disabled: false,
        exact: true,
        to: {
          name: "privilegios_usuario_perfiles",
          params: {
            usuario: this.serviceCommons.objectToBase64(this.usuario)
          }
        }
      });
      this.breadcrumbs.push({
        text: "Personalizados",
        disabled: true
      });
    },
    getPerfilesUsuarioDisponibles() {
      var self = this;
      axios
        .get(
          "/usuario/secure/get/perfiles/available/" + this.usuario.id_usuario
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setPerfilesUsuarioDisponibles(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setPerfilesUsuarioDisponibles(data) {
      if (data) {
        this.perfilesUsuarioDisponibles = data;
      }
    },
    getPerfilesUsuarioFijos() {
      var self = this;
      axios
        .get("/usuario/secure/get/perfiles/fixed/" + this.usuario.id_usuario)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setPerfilesUsuarioFijos(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setPerfilesUsuarioFijos(data) {
      if (data) {
        this.perfilesUsuarioFijos = data;
      }
    },
    getPerfilesUsuarioAsociados() {
      var self = this;
      axios
        .get(
          "/usuario/secure/get/perfiles/associated/" + this.usuario.id_usuario
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setPerfilesUsuarioAsociados(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setPerfilesUsuarioAsociados(data) {
      if (data) {
        this.perfilesUsuarioAsociados = data;
      }
    },
    postAssociatePerfilUsuario(perfil) {
      var self = this;
      perfil.id_empleado = this.usuario.id_usuario;
      perfil.personalizado = 1;
      axios
        .post("/usuario/secure/post/perfiles", perfil)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.perfilesUsuarioAsociados = self.perfilesUsuarioAsociados.map(
                (item) => {
                  if (item.id_perfil_usuario === data.id_perfil_usuario) {
                    item.id_perfil_usuario = data.id_perfil_usuario;
                  }
                  return item;
                }
              );
            } else {
              self.rollbackAdd();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    deleteAssociatePerfilUsuario(itemToDelete) {
      var self = this;
      axios
        .delete("/usuario/secure/delete/perfiles", { data: itemToDelete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.deletePerfilUsuario(itemToDelete);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    rollbackAdd() {
      let itemToAdd = this.removed.element;
      if (this.perfilesUsuarioAsociados) {
        this.perfilesUsuarioAsociados = this.perfilesUsuarioAsociados.filter(
          (item) => {
            if (item.perfil.id_perfil !== itemToAdd.perfil.id_perfil) {
              return item;
            }
          }
        );
        this.perfilesUsuarioDisponibles.splice(
          this.removed.oldIndex,
          0,
          itemToAdd
        );
      }
    },
    deletePerfilUsuario(itemToDelete) {
      if (this.perfilesUsuarioAsociados) {
        let perfilPerfilToDelete;
        this.perfilesUsuarioAsociados = this.perfilesUsuarioAsociados.filter(
          (item) => {
            if (item.perfil.id_perfil === itemToDelete.perfil.id_perfil) {
              perfilPerfilToDelete = item;
            } else {
              return item;
            }
          }
        );
        if (perfilPerfilToDelete) {
          this.perfilesUsuarioDisponibles.push(perfilPerfilToDelete);
        }
      }
    },
    onDragDrop(event) {
      if (event.added) {
        this.postAssociatePerfilUsuario(event.added.element);
      }
      if (event.removed) {
        this.removed = event.removed;
      }
    },
    onCreated() {
      if (this.$route.params.usuario) {
        this.usuario = this.serviceCommons.base64ToObject(
          this.$route.params.usuario
        );
      }
      this.initValues();
      this.getPerfilesUsuarioDisponibles();
      this.getPerfilesUsuarioFijos();
      this.getPerfilesUsuarioAsociados();
    }
  },
  created() {
    this.onCreated();
  }
};
</script>
